//datos del usuario
var usuario = {};
//datos del taxista
var taxi = {};
//datos del servicio
var servicio = {};
//numero de mensajer
var chatNumero = 0;
//tiempo de espera entre las actualizaciones del estado del servicio
var sleepActualizacion = 10000;
var sleepCarga = 1000;
//variables de carga para google maps
var map = null;
var mapOk = false;
//control general de la aplicacion
var app = {
    // Application Constructor
    initialize: function () {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function () {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicitly call 'app.receivedEvent(...);'
    onDeviceReady: function () {
        app.index();
    },
    index: function () {

        //verifica si ya existe un usuario cargado en el sistema
        try {
            usuario = JSON.parse(localStorage.getItem('usuario'));
            if (usuario.id_taxi_usuario * 1 > 0) {
                conexion.sendArray('usuarioDatos', {id_taxi_usuario: usuario.id_taxi_usuario});
                if (conexion.result.errorCode == 0) {
                    localStorage.clear();
                    usuario = conexion.result.usuario;
                    localStorage.setItem("usuario", JSON.stringify(usuario));
                    app.nuevoServicio();
                }
            }
        } catch (e) {

        }

        $("#usuarioRegistro").validate({
            submitHandler: function () {
                conexion.send('#usuarioRegistro');
                if (conexion.result.errorCode == 0) {
                    localStorage.clear();
                    usuario = conexion.result.usuario;
                    localStorage.setItem("usuario", JSON.stringify(usuario));
                    app.nuevoServicio();
                } else {
                    alert(conexion.result.errorText);
                }
            }
        });
    },
    nuevoServicio: function () {
        $.mobile.pageContainer.pagecontainer("change", "nuevoServicio.html", {transition: "pop"});
        setTimeout(function () {
            app.googleMaps("map_canvas");
            setTimeout(function () {
                conexion.sendArray('usuarioTaxiTodos', usuario);
                if (conexion.result.errorCode == 0) {
                    taxis = conexion.result.taxis;

                    map.clear();

                    for (i = 0; i < taxis.length; i++) {
                        map.addMarker({
                            'position': {
                                lat: taxis[i].latitud_taxi_ubicacion,
                                lng: taxis[i].longitud_taxi_ubicacion
                            },
                            'icon': "http://www.fullcarrera.com/static/iconTaxi.png",
                            'size': {
                                width: 20,
                                height: 31
                            }
                        });
                    }

                } else {
                    alert(conexion.result.errorText);
                }
            }, sleepCarga);
        }, sleepCarga);
    },
    confirmarServicio: function () {
        //hace reset al servicio
        servicio = {};
        //carga la dirección y la ubicación
        map.getCameraPosition(function (camera) {
            app.googleMapsDireccion(camera.target);
        });
        $.mobile.pageContainer.pagecontainer("change", "confirmarServicio.html", {transition: "pop"});
        setTimeout(function () {
            //carga la dirección del usuario
            direccion = servicio.direccion_taxi_servicio.split("-");
            $('#direccion_taxi_servicio').val(direccion[0]);
            //envia el los datos para crear el nuevo servicio
            $("#usuarioNuevoServicio").validate({
                submitHandler: function () {
                    //carga los datos al servicio
                    servicio.direccion_taxi_servicio = $('#direccion_taxi_servicio').val();
                    servicio.referencia_taxi_servicio = $('#referencia_taxi_servicio').val();
                    servicio.vehiculo_taxi_servicio = $('#vehiculo_taxi_servicio').val();
                    //envia el formulario
                    conexion.sendArray('usuarioNuevoServicio', servicio);
                    if (conexion.result.errorCode == 0) {
                        servicio = conexion.result.servicio
                        app.esperandoTaxi();
                    } else {
                        alert(conexion.result.errorText);
                    }
                }
            });
        }, sleepCarga);
    },
    esperandoTaxi: function () {
        $.mobile.pageContainer.pagecontainer("change", "esperandoTaxi.html", {transition: "pop"});
        setTimeout(function () {
            app.googleMaps("map_canvas_esperando_taxi");
            app.esperandoTaxiServicio();
            //limpia los datos del taxi
            $('#placa').html("");
            $('#nombre').html("");
            $('#celular').html("");
            $('#foto').attr('src', "");

            app.esperandoTaxiChatConsultar();
        }, sleepCarga);
    },
    esperandoTaxiCancelar: function () {
        conexion.sendArray('usuarioServicio', servicio);
        if (conexion.result.errorCode == 0) {
            app.nuevoServicio();
        } else {
            alert(conexion.result.errorText);
        }
    },
    esperandoTaxiServicio: function () {
        setTimeout(function () {
            conexion.sendArray('usuarioServicio', servicio);
            if (conexion.result.errorCode == 0) {
                servicio = conexion.result.servicio
                if (servicio.id_taxi_taxi * 1 > 0) {
                    app.esperandoTaxiUbicacion();
                    document.getElementById('nuevoSercioAlerta').play();
                    $('#usuarioChat').show();
                    $('#esperandoTaxi').hide();
                    //carga los datos del taxi
                    $('#placa').html(servicio.placa_taxi_taxi);
                    $('#nombre').html(servicio.nombre_taxi_taxi);
                    $('#celular').html(servicio.celular_taxi_taxi);
                    $('#foto').attr('src', "http://fullcarrera.com"+servicio.foto_taxi_taxi);
                } else {
                    app.esperandoTaxiServicio();
                }
            } else {
                app.esperandoTaxiServicio();
            }
        }, sleepActualizacion);
    },
    esperandoTaxiUbicacion: function () {
        setTimeout(function () {
            conexion.sendArray('usuarioTaxiUbicacion', servicio);
            if (conexion.result.errorCode == 0) {
                taxi = conexion.result.taxi;
                map.clear();
                map.addMarker({
                    'position': {
                        lat: taxi.latitud_taxi_ubicacion,
                        lng: taxi.longitud_taxi_ubicacion
                    },
                    'icon': "http://www.fullcarrera.com/static/iconTaxi.png",
                    'size': {
                        width: 30,
                        height: 46
                    }
                });
                map.animateCamera({
                    target: {
                        lat: taxi.latitud_taxi_ubicacion,
                        lng: taxi.longitud_taxi_ubicacion
                    }
                    ,
                    zoom: 16
                });
                app.esperandoTaxiUbicacion();
            } else {
                //el taxi ha llegado
                document.getElementById('nuevoSercioAlerta').play();
                app.calificar();
            }
        }, sleepActualizacion);
    },
    esperandoTaxiChat: function (mensaje) {
        chat = {};
        chat.mensaje_taxi_chat = mensaje;
        chat.id_taxi_tipo_chat = 1;
        chat.id_taxi_servicio = servicio.id_taxi_servicio;
        conexion.sendArray('guardarChat', chat);
        if (conexion.result.errorCode != 0) {
            alert(conexion.result.errorText);
        }
    },
    esperandoTaxiChatConsultar: function () {
        setTimeout(function () {
            conexion.sendArray('consultarChat', servicio);
            if (conexion.result.errorCode == 0) {
                chat = conexion.result.chat;
                if (chatNumero != chat.length) {
                    document.getElementById('nuevoSercioAlerta').play();
                    chatNumero = chat.length;
                }
                $('#chat').html("");
                for (i = 0; i < chat.length; i++) {
                    if (chat[i].id_taxi_tipo_chat == 1) {
                        $('#chat').html("<div style='text-align: left; width: 98%; background-color: #FFFFFF; margin: 1px 1px; padding:2px 2px; border-radius: 10px;'>" + chat[i].mensaje_taxi_chat + "</div>" + $('#chat').html());
                    } else {
                        $('#chat').html("<div style='text-align: right; width: 98%; background-color: #ffffc0; margin: 1px 1px; padding:2px 2px; border-radius: 10px;'>" + chat[i].mensaje_taxi_chat + "</div>" + $('#chat').html());
                    }
                }
                app.esperandoTaxiChatConsultar();
            }
        }, sleepActualizacion);
    },
    calificar: function () {
        $.mobile.pageContainer.pagecontainer("change", "calificar.html", {transition: "pop"});
        setTimeout(function () {
            //busca las calificaciones disponibles
            conexion.sendArray('usuarioCalificacion', usuario);
            if (conexion.result.errorCode == 0) {
                calificaciones = conexion.result.calificaciones;
                for (i = 0; i < calificaciones.length; i++) {
                    $('#id_taxi_calificacion').append("<option value='" + calificaciones[i].id_taxi_calificacion + "'>" + calificaciones[i].nombre_taxi_calificacion + "</option>");
                }
            } else {
                alert(conexion.result.errorText);
            }

            //carga el id del taxi en el formulario
            $('#calificacionTaxi').val(servicio.id_taxi_taxi);

            //envia la calificacion
            $("#usuarioGuardarCalificacion").validate({
                submitHandler: function () {
                    conexion.send('#usuarioGuardarCalificacion');
                    if (conexion.result.errorCode == 0) {
                        app.nuevoServicio();
                    } else {
                        alert(conexion.result.errorText);
                    }
                }
            });
        }, sleepCarga);
    },
    historial: function () {
        $.mobile.pageContainer.pagecontainer("change", "historial.html", {transition: "pop"});
        setTimeout(function () {
            conexion.sendArray('usuarioHistorial', usuario);
            if (conexion.result.errorCode == 0) {
                historial = conexion.result.historial;
                for (i = 0; i < historial.length; i++) {
                    $('#historialServicios').append("<tr><td>" + historial[i].id_taxi_servicio + "</td><td>" + historial[i].creacion_taxi_servicio + "</td><td>" + historial[i].direccion_taxi_servicio + "</td><td>" + historial[i].nombre_taxi_estado + "</td></tr>");
                }
            } else {
                alert(conexion.result.errorText);
            }
        }, sleepCarga);
    },
    googleMaps: function (canvas) {
        var div = document.getElementById(canvas);
        map = plugin.google.maps.Map.getMap(div);
        map.addEventListener(plugin.google.maps.event.MAP_READY, app.googleMapsIsReady());
    },
    googleMapsIsReady: function () {
        mapOk = true;
        map.clear();
        setTimeout(function () {
            app.googleMapsUbicacion();
        }, sleepCarga);
    },
    googleMapsUbicacion: function () {
        map.getMyLocation(function (location) {
            map.animateCamera({
                target: {
                    lat: location.latLng.lat,
                    lng: location.latLng.lng
                }
                ,
                zoom: 16
            });
        });
    },
    googleMapsDireccion: function (position) {
        plugin.google.maps.Geocoder.geocode({'position': position}, function (results) {
            if (results.length) {
                servicio.direccion_taxi_servicio = results[0].extra.lines[0];
            }
            servicio.id_taxi_usuario = usuario.id_taxi_usuario;
            servicio.latitud_taxi_servicio = position.lat;
            servicio.longitud_taxi_servicio = position.lng;
        });
    }
};
app.initialize();


//bloquea el boton atras 
document.addEventListener("backbutton", onBackKeyDown, false);
function onBackKeyDown(e) {
    e.preventDefault();
}